﻿Imports System.ComponentModel

Partial Public Class MainPage
    Inherits UserControl
    Implements INotifyPropertyChanged

    Dim people As New System.Collections.ObjectModel.ObservableCollection(Of PersonName)()
    Public Sub New()
        InitializeComponent()
        people.Add(New PersonName("Johnathan", "Gartner"))
        people.Add(New PersonName("Jeannine", "Richart"))
        people.Add(New PersonName("Merry", "Sparacino"))
        people.Add(New PersonName("Sandi", "Willman"))
        people.Add(New PersonName("Damion", "Dagley"))
        people.Add(New PersonName("Johnathan", "Gartner"))
        people.Add(New PersonName("Jeannine", "Richart"))
        people.Add(New PersonName("Merry", "Sparacino"))
        people.Add(New PersonName("Sandi", "Willman"))
        people.Add(New PersonName("Damion", "Dagley"))
        people.Add(New PersonName("Johnathan", "Gartner"))
        people.Add(New PersonName("Jeannine", "Richart"))
        people.Add(New PersonName("Merry", "Sparacino"))
        people.Add(New PersonName("Sandi", "Willman"))
        people.Add(New PersonName("Damion", "Dagley"))
        DataGrid.ItemsSource = people
    End Sub

    Dim selectedRows As New List(Of Integer)
    Private Sub DataGrid_BeginningEdit(sender As Object, e As C1.Silverlight.DataGrid.DataGridBeginningEditEventArgs) Handles DataGrid.BeginningEdit
        e.Cancel = True
    End Sub
    Private Sub DataGrid_LoadedRowPresenter(sender As Object, e As C1.Silverlight.DataGrid.DataGridRowEventArgs) Handles DataGrid.LoadedRowPresenter
        AddHandler e.Row.Presenter.MouseLeftButtonUp, AddressOf RowPresenter_MouseLeftButtonUp
    End Sub

    Private Sub DataGrid_MouseLeftButtonUp(sender As Object, e As MouseButtonEventArgs) Handles DataGrid.MouseLeftButtonUp
        e.Handled = True
        Me.DataGrid.Selection.Clear()
        For i As Integer = 0 To selectedRows.Count - 1
            Me.DataGrid.Selection.Add(New C1.Silverlight.DataGrid.DataGridCellsRange(Me.DataGrid.Rows(selectedRows(i))))
        Next
        SelectedRowCountBlock.Text = "Selected RowCount : " & Me.DataGrid.Selection.SelectedRows.Count
    End Sub

    Public Event PropertyChanged(sender As Object, e As PropertyChangedEventArgs) Implements INotifyPropertyChanged.PropertyChanged

    Private Sub DataGrid_UnloadedRowPresenter(sender As Object, e As C1.Silverlight.DataGrid.DataGridRowEventArgs) Handles DataGrid.UnloadedRowPresenter
        RemoveHandler e.Row.Presenter.MouseLeftButtonUp, AddressOf RowPresenter_MouseLeftButtonUp
    End Sub

    Private Sub RowPresenter_MouseLeftButtonUp(sender As Object, e As MouseButtonEventArgs)
        Dim rowIndex = DirectCast(sender, C1.Silverlight.DataGrid.DataGridRowPresenter).Row.Index
        If Not selectedRows.Contains(rowIndex) Then
            selectedRows.Add(rowIndex)
        Else
            selectedRows.Remove(rowIndex)
        End If
    End Sub

End Class

Public Class PersonName
    ' Methods 
    Public Sub New(ByVal first As String, ByVal last As String)
        Me._firstName = first
        Me._lastName = last
    End Sub
    ' Properties 
    Public Property FirstName() As String
        Get
            Return Me._firstName
        End Get
        Set(ByVal value As String)
            Me._firstName = value
        End Set
    End Property

    Public Property LastName() As String
        Get
            Return Me._lastName
        End Get
        Set(ByVal value As String)
            Me._lastName = value
        End Set
    End Property
    ' Fields 
    Private _firstName As String
    Private _lastName As String
End Class
